Last Comment Bug 844921 - Camera - expose supported picture sizes in camera app
: Camera - expose supported picture sizes in camera app
Status: RESOLVED FIXED
:
Product: Firefox OS
Classification: Client Software
Component: Gaia::Camera (show other bugs)
: unspecified
: ARM Gonk (Firefox OS)
: -- normal (vote)
: ---
Assigned To: Wilson Page [:wilsonpage]
: John Hammink
:
Mentors:
Depends on:
Blocks: 844920
  Show dependency treegraph
 
Reported: 2013-02-25 10:11 PST by Mike Habicher [:mikeh] (high bugzilla latency)
Modified: 2014-04-02 06:28 PDT (History)
11 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
-


Attachments

Description Mike Habicher [:mikeh] (high bugzilla latency) 2013-02-25 10:11:08 PST

    
Comment 1 Michael Vines [:m1] [:evilmachines] 2013-02-25 10:19:49 PST
Requesting blocking for leo, as without then based on this comment we will have a downstream gaia fork: https://bugzilla.mozilla.org/show_bug.cgi?id=838512#c2
Comment 2 Mike Habicher [:mikeh] (high bugzilla latency) 2013-02-25 10:22:57 PST
CCing dale since he'd like be the one tweaking the camera app.

djf, one challenge will be making sure that we have the memory available to post-process 5MP images, which is part of the reason we limited captures to 2MP in the first place, even on hardware that supports higher resolutions.  Any thoughts on how to approach this?
Comment 3 Michael Vines [:m1] [:evilmachines] 2013-02-25 10:24:35 PST
Even with 512MB RAM?
Comment 4 Mike Habicher [:mikeh] (high bugzilla latency) 2013-02-25 10:30:41 PST
(In reply to Michael Vines [:m1] [:evilmachines] from comment #3)
>
> Even with 512MB RAM?

No, but we ran into memory issues with images >2MP on platforms with only 256MB.
Comment 5 Michael Vines [:m1] [:evilmachines] 2013-02-25 10:35:48 PST
Good, we're targeting 512MB for leo
Comment 6 David Flanagan [:djf] 2013-02-25 10:52:42 PST
I have not tested the memory required for editing and saving larger files. We should be sure we can do that comfortably for any resolution we support. The edit UI works on a screen-sized image until you actually click the check box to save your edit. Only then does send the full image through WebGL and through canvas.getBlob().

The memory issues that prompted the current 2 megapixle restrictions were related to just displaying the images in the gallery. The app needs to keep three images decoded at a time (current next and previous). And, gecko does not always free image memory promptly. So we were finding that rapidly flicking through the images could cause an OOM.

This issue has been resolved by displaying the embedded preview image (when it is available) instead of the fullsize image and only decoding the full image when the user actually wants to zoom in.

With that change, it is probably safe to lift the 2mp restriction.  I don't advocate changing the default resolution, however. I'm not sure that anyone actually wants bigger images on entry level phones with tiny fixed-focus cameras.
Comment 7 David Flanagan [:djf] 2013-02-25 10:55:56 PST
Is this bug about adding new UX to the camera to allow the user to select an image size?  If so, we need to get the UX team involved.

Or is it about adding a build-time configuration option so that our partners can easily configure the fixed image size?
Comment 8 Leo 2013-03-04 17:50:30 PST
As we want to use 5MP resolution for Camera capture, Please provide us one of the following options:
1. Support for Multi resolution 2MP and 5MP, so that we will use 5MP option for our device.
2. Change current implementation to support 5MP resolution just for Leo.

Please give your reply As soon as possible.
Comment 9 Dietrich Ayala (:dietrich) 2013-03-11 16:52:04 PDT
Not blocking on original report, is a new feature that is not a P1 for 1.1.
Comment 10 Dietrich Ayala (:dietrich) 2013-03-11 16:52:24 PDT
(In reply to leo.bugzilla.gaia from comment #8)
> As we want to use 5MP resolution for Camera capture, Please provide us one
> of the following options:
> 1. Support for Multi resolution 2MP and 5MP, so that we will use 5MP option
> for our device.
> 2. Change current implementation to support 5MP resolution just for Leo.
> 
> Please give your reply As soon as possible.

Please file a separate bug for that.
Comment 12 Wilson Page [:wilsonpage] 2014-04-02 06:28:15 PDT
Closing. This has landed as part of the 1.4 camera.

Note You need to log in before you can comment on or make changes to this bug.